/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractInplaceInput;
import org.richfaces.component.InplaceState;

/**
 *  @author Anton Belevich 


 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIInplaceInput extends AbstractInplaceInput
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.InplaceInput";

    public static final String COMPONENT_FAMILY="org.richfaces.InplaceInput";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIInplaceInput() {
        super();
        setRendererType("org.richfaces.InplaceInputRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "mousedown",
        "inputblur",
        "mouseover",
        "mousemove",
        "ondblclick",
        "keydown",
        "mouseout",
        "inputmouseover",
        "inputselect",
        "inputkeydown",
        "keypress",
        "inputmouseup",
        "mouseup",
        "inputdblclick",
        "keyup",
        "click",
        "blur",
        "inputchange",
        "inputkeyup",
        "inputclick",
        "inputmousemove",
        "inputkeypress",
        "inputfocus",
        "focus",
        "inputmouseout",
        "inputmousedown"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        changedStateClass,
        defaultLabel,
        disableStateClass,
        editClass,
        editEvent,
        editStateClass,
        inputWidth,
        noneClass,
        onblur,
        onclick,
        ondblclick,
        onfocus,
        oninputblur,
        oninputchange,
        oninputclick,
        oninputdblclick,
        oninputfocus,
        oninputkeydown,
        oninputkeypress,
        oninputkeypup,
        oninputmousedown,
        oninputmousemove,
        oninputmouseout,
        oninputmouseover,
        oninputmouseup,
        oninputselect,
        onkeydown,
        onkeypress,
        onkeypup,
        onmousedown,
        onmousemove,
        onmouseout,
        onmouseover,
        onmouseup,
        readyStateClass,
        saveOnBlur,
        showControls,
        state,
        tabIndex

    }


 
    public String getChangedStateClass() {
        return (String) getStateHelper().eval(Properties.changedStateClass);
    }
    
    public void setChangedStateClass(String changedStateClass) {
        getStateHelper().put(Properties.changedStateClass, changedStateClass);
    }

 
    public String getDefaultLabel() {
        return (String) getStateHelper().eval(Properties.defaultLabel);
    }
    
    public void setDefaultLabel(String defaultLabel) {
        getStateHelper().put(Properties.defaultLabel, defaultLabel);
    }

 
    public String getDisableStateClass() {
        return (String) getStateHelper().eval(Properties.disableStateClass);
    }
    
    public void setDisableStateClass(String disableStateClass) {
        getStateHelper().put(Properties.disableStateClass, disableStateClass);
    }

 
    public String getEditClass() {
        return (String) getStateHelper().eval(Properties.editClass);
    }
    
    public void setEditClass(String editClass) {
        getStateHelper().put(Properties.editClass, editClass);
    }

 
    public String getEditEvent() {
        return (String) getStateHelper().eval(Properties.editEvent, "click");
    }
    
    public void setEditEvent(String editEvent) {
        getStateHelper().put(Properties.editEvent, editEvent);
    }

 
    public String getEditStateClass() {
        return (String) getStateHelper().eval(Properties.editStateClass);
    }
    
    public void setEditStateClass(String editStateClass) {
        getStateHelper().put(Properties.editStateClass, editStateClass);
    }

 
    public String getInputWidth() {
        return (String) getStateHelper().eval(Properties.inputWidth, "100%");
    }
    
    public void setInputWidth(String inputWidth) {
        getStateHelper().put(Properties.inputWidth, inputWidth);
    }

 
    public String getNoneClass() {
        return (String) getStateHelper().eval(Properties.noneClass);
    }
    
    public void setNoneClass(String noneClass) {
        getStateHelper().put(Properties.noneClass, noneClass);
    }

 
    public String getOnblur() {
        return (String) getStateHelper().eval(Properties.onblur);
    }
    
    public void setOnblur(String onblur) {
        getStateHelper().put(Properties.onblur, onblur);
    }

 
    public String getOnclick() {
        return (String) getStateHelper().eval(Properties.onclick);
    }
    
    public void setOnclick(String onclick) {
        getStateHelper().put(Properties.onclick, onclick);
    }

 
    public String getOndblclick() {
        return (String) getStateHelper().eval(Properties.ondblclick);
    }
    
    public void setOndblclick(String ondblclick) {
        getStateHelper().put(Properties.ondblclick, ondblclick);
    }

 
    public String getOnfocus() {
        return (String) getStateHelper().eval(Properties.onfocus);
    }
    
    public void setOnfocus(String onfocus) {
        getStateHelper().put(Properties.onfocus, onfocus);
    }

 
    public String getOninputblur() {
        return (String) getStateHelper().eval(Properties.oninputblur);
    }
    
    public void setOninputblur(String oninputblur) {
        getStateHelper().put(Properties.oninputblur, oninputblur);
    }

 
    public String getOninputchange() {
        return (String) getStateHelper().eval(Properties.oninputchange);
    }
    
    public void setOninputchange(String oninputchange) {
        getStateHelper().put(Properties.oninputchange, oninputchange);
    }

 
    public String getOninputclick() {
        return (String) getStateHelper().eval(Properties.oninputclick);
    }
    
    public void setOninputclick(String oninputclick) {
        getStateHelper().put(Properties.oninputclick, oninputclick);
    }

 
    public String getOninputdblclick() {
        return (String) getStateHelper().eval(Properties.oninputdblclick);
    }
    
    public void setOninputdblclick(String oninputdblclick) {
        getStateHelper().put(Properties.oninputdblclick, oninputdblclick);
    }

 
    public String getOninputfocus() {
        return (String) getStateHelper().eval(Properties.oninputfocus);
    }
    
    public void setOninputfocus(String oninputfocus) {
        getStateHelper().put(Properties.oninputfocus, oninputfocus);
    }

 
    public String getOninputkeydown() {
        return (String) getStateHelper().eval(Properties.oninputkeydown);
    }
    
    public void setOninputkeydown(String oninputkeydown) {
        getStateHelper().put(Properties.oninputkeydown, oninputkeydown);
    }

 
    public String getOninputkeypress() {
        return (String) getStateHelper().eval(Properties.oninputkeypress);
    }
    
    public void setOninputkeypress(String oninputkeypress) {
        getStateHelper().put(Properties.oninputkeypress, oninputkeypress);
    }

 
    public String getOninputkeypup() {
        return (String) getStateHelper().eval(Properties.oninputkeypup);
    }
    
    public void setOninputkeypup(String oninputkeypup) {
        getStateHelper().put(Properties.oninputkeypup, oninputkeypup);
    }

 
    public String getOninputmousedown() {
        return (String) getStateHelper().eval(Properties.oninputmousedown);
    }
    
    public void setOninputmousedown(String oninputmousedown) {
        getStateHelper().put(Properties.oninputmousedown, oninputmousedown);
    }

 
    public String getOninputmousemove() {
        return (String) getStateHelper().eval(Properties.oninputmousemove);
    }
    
    public void setOninputmousemove(String oninputmousemove) {
        getStateHelper().put(Properties.oninputmousemove, oninputmousemove);
    }

 
    public String getOninputmouseout() {
        return (String) getStateHelper().eval(Properties.oninputmouseout);
    }
    
    public void setOninputmouseout(String oninputmouseout) {
        getStateHelper().put(Properties.oninputmouseout, oninputmouseout);
    }

 
    public String getOninputmouseover() {
        return (String) getStateHelper().eval(Properties.oninputmouseover);
    }
    
    public void setOninputmouseover(String oninputmouseover) {
        getStateHelper().put(Properties.oninputmouseover, oninputmouseover);
    }

 
    public String getOninputmouseup() {
        return (String) getStateHelper().eval(Properties.oninputmouseup);
    }
    
    public void setOninputmouseup(String oninputmouseup) {
        getStateHelper().put(Properties.oninputmouseup, oninputmouseup);
    }

 
    public String getOninputselect() {
        return (String) getStateHelper().eval(Properties.oninputselect);
    }
    
    public void setOninputselect(String oninputselect) {
        getStateHelper().put(Properties.oninputselect, oninputselect);
    }

 
    public String getOnkeydown() {
        return (String) getStateHelper().eval(Properties.onkeydown);
    }
    
    public void setOnkeydown(String onkeydown) {
        getStateHelper().put(Properties.onkeydown, onkeydown);
    }

 
    public String getOnkeypress() {
        return (String) getStateHelper().eval(Properties.onkeypress);
    }
    
    public void setOnkeypress(String onkeypress) {
        getStateHelper().put(Properties.onkeypress, onkeypress);
    }

 
    public String getOnkeypup() {
        return (String) getStateHelper().eval(Properties.onkeypup);
    }
    
    public void setOnkeypup(String onkeypup) {
        getStateHelper().put(Properties.onkeypup, onkeypup);
    }

 
    public String getOnmousedown() {
        return (String) getStateHelper().eval(Properties.onmousedown);
    }
    
    public void setOnmousedown(String onmousedown) {
        getStateHelper().put(Properties.onmousedown, onmousedown);
    }

 
    public String getOnmousemove() {
        return (String) getStateHelper().eval(Properties.onmousemove);
    }
    
    public void setOnmousemove(String onmousemove) {
        getStateHelper().put(Properties.onmousemove, onmousemove);
    }

 
    public String getOnmouseout() {
        return (String) getStateHelper().eval(Properties.onmouseout);
    }
    
    public void setOnmouseout(String onmouseout) {
        getStateHelper().put(Properties.onmouseout, onmouseout);
    }

 
    public String getOnmouseover() {
        return (String) getStateHelper().eval(Properties.onmouseover);
    }
    
    public void setOnmouseover(String onmouseover) {
        getStateHelper().put(Properties.onmouseover, onmouseover);
    }

 
    public String getOnmouseup() {
        return (String) getStateHelper().eval(Properties.onmouseup);
    }
    
    public void setOnmouseup(String onmouseup) {
        getStateHelper().put(Properties.onmouseup, onmouseup);
    }

 
    public String getReadyStateClass() {
        return (String) getStateHelper().eval(Properties.readyStateClass);
    }
    
    public void setReadyStateClass(String readyStateClass) {
        getStateHelper().put(Properties.readyStateClass, readyStateClass);
    }

 
    public boolean isSaveOnBlur() {
        return Boolean.valueOf(getStateHelper().eval(Properties.saveOnBlur, true).toString());
    }
    
    public void setSaveOnBlur(boolean saveOnBlur) {
        getStateHelper().put(Properties.saveOnBlur, saveOnBlur);
    }

 
    public boolean isShowControls() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showControls, false).toString());
    }
    
    public void setShowControls(boolean showControls) {
        getStateHelper().put(Properties.showControls, showControls);
    }

 
    public org.richfaces.component.InplaceState getState() {
        return (InplaceState) getStateHelper().eval(Properties.state, InplaceState.ready);
    }
    
    public void setState(org.richfaces.component.InplaceState state) {
        getStateHelper().put(Properties.state, state);
    }

 
    public String getTabIndex() {
        return (String) getStateHelper().eval(Properties.tabIndex);
    }
    
    public void setTabIndex(String tabIndex) {
        getStateHelper().put(Properties.tabIndex, tabIndex);
    }

}